Attribute VB_Name = "Module1"
Option Explicit

Public Sub ordenar_datagrid(ByVal ColIndex As Integer, _
                           rs As ADODB.Recordset, _
                           DataGrid As DataGrid)

    Dim strColName As String
    Static bSortAsc As Boolean
    Static strPrevCol As String
    Dim orden As String
    
    strColName = "[" & DataGrid.Columns(ColIndex).DataField & "]"
 
    If strColName = strPrevCol Then

        If bSortAsc Then
            rs.Sort = strColName & " DESC"
            bSortAsc = False
        Else
            rs.Sort = strColName
            bSortAsc = True
        End If

    Else
        rs.Sort = strColName
        bSortAsc = True
    End If
    strPrevCol = strColName
    
    If bSortAsc Then
       orden = "ORDER BY " & strColName & " Asc"
    Else
       orden = "ORDER BY " & strColName & " Desc"
    End If
    
    Call Guardar_Orden_DataGrid(DataGrid, orden)
    
End Sub

Function Leer_Orden_Datagrid(DataGrid As DataGrid) As String
    Dim Name_DataGrid As String
    Name_DataGrid = DataGrid.Parent.Name & DataGrid.Name
    
    On Local Error GoTo err_fun
    
    Dim ret As String
    ret = GetSetting(App.EXEName, _
                    "OrdenColumnaDatagrids", _
                     Name_DataGrid, "")
    
    Leer_Orden_Datagrid = ret
    
Exit Function
err_fun:
Debug.Print Err.Description
End Function

Sub Guardar_Orden_DataGrid( _
    DataGrid As DataGrid, _
    orden As String)
    
    On Local Error GoTo err_sub
    
    Dim Name_DataGrid As String
    Name_DataGrid = DataGrid.Parent.Name & DataGrid.Name
    
    SaveSetting App.EXEName, _
                "OrdenColumnaDatagrids", _
                Name_DataGrid, _
                orden
    

Exit Sub
err_sub:
Debug.Print Err.Description

End Sub
